/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/2/3
 * Time: 下午3:50
 * To change this template use File | Settings | File Templates.
 */

var GameMessage = {

	//
	Mes_FirstAward			: "奖励15钻石！",
	Mes_WantToBuy			: "您想买吗?",
	Mes_WantToTopUp			: "你想买更多的钻石吗？",
	Mes_WantToTopUp2		: "没有足够的钻石，看视频即可获得随机2到10颗钻石！",
	Mes_WantToTopUp3		: "购买《勇者宝箱》只需20元，可获得120颗钻石+30万金币+指南针一次。",
	Mes_DeadSave			: "花40钻石保存你的进度（行李、装备、钱币）！",
	Mes_SpecialEquipDes : [
		"当生命下降到0%时,恢复100% 死亡后满血复活。",
		"使用后打开特殊的箱子! ",
		"通关一层增加5步。",
		"过关后可以带走所有物品和装备。",
		"在迷宫死亡的时候，刚获得的装备物品将不会丢失。",
		"武器装备增加50%属性。"
	],
	Mes_PackFull			: "背包已满，请扔掉您不需要的东西。",
	Mes_PackFull2			: "背包已满，请您到商店购买新的背包。",
	Mes_UseTp				: "当您意外离开迷宫时候，已经获得的物品和金币不会丢失。",
	Mes_UseBlessed			: "在迷宫死亡的时候，刚获得的装备物品不会丢失。",
	Mes_GetJewel			: "恭喜您获得1钻石！",
	Mes_GetJewel2			: "恭喜您获得5钻石！",
	Mes_SelectFloor			: "人物等级会在离开迷宫的时候重置，建议您从低级一点的迷宫开始冒险。",
	Mes_TopUpSaveEquip		: "购买成功，恭喜您获得199钻石！",

	//---------------------------------------------------------------------------------------------------------------------------
	//战斗信息
	
	//胜利结果信息
	getFightWinResultMessage : function()
	{
		var oWinResult = FightManager.getWinResult();
		var oFightResult = FightManager.getFightResult();
		var strContent = "您战胜了 " + oFightResult.m_strEnemyName + "\n"
			+ "金币：+" + oWinResult.m_nCoin + "\n"
			+ "经验：+"   + oWinResult.m_nExp + "\n"
			+ "等级："  + oWinResult.m_nLvPre + " -> " + oWinResult.m_nLvCur + "\n"
			+ "步数："  + oFightResult.m_nChangeStep;

		return strContent;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//道具信息

	//特殊道具说明
	getEquipMessage : function(oEquip)
	{
		var strContent = oEquip.m_oData.Name + "\n";
		strContent += this.getEquipValueMessage(oEquip, false, false);
		return strContent;
	},
	//道具属性说明
	getEquipValueMessage : function(oEquip, bLv, bShort)
	{
		//内容
		var strContent = "";
		//等级
		if(bLv){
			strContent += "等级: " + oEquip.m_oCoe.m_nLv + "\n";
		}
		//属性
		for(var i = 1; i < 3; i++)
		{
			//得到属性
			var oAttrItem = oEquip.getAttrById(i);
			if(!oAttrItem){
				break;
			}
			//计算数值
			var nValue = oEquip.getAttrValueById(i);
			var bIsInteger = StaticMethod.isInteger(oAttrItem.m_nValue);
			if(bShort){
				strContent += StaticMethod.getPropertyStr2(oAttrItem.m_nType, nValue, bIsInteger) + "\n";
			}else{
				strContent += StaticMethod.getPropertyStr(oAttrItem.m_nType, nValue, bIsInteger) + "\n";
			}
		}
		//
		return strContent;
	},
	//升级说明
	upgradeEquipMessage : function(oEquip)
	{
		//显示
		var strContent = "提升 " + oEquip.m_oData.Name + " 至" + (oEquip.m_oCoe.m_nLv+1) + "级？\n";
		//属性
		for(var i = 1; i < 3; i++)
		{
			//得到属性
			var oProItem = oEquip.getAttrById(i);
			if(!oProItem){
				break;
			}
			//计算数值
			var nValue = oEquip.getAttrValueById(i);
			var bIsInteger = StaticMethod.isInteger(oProItem.m_nValue);

			//升级道具后的属性
			oEquip.m_oCoe.m_nLv++;

			var nValue2 = oEquip.getAttrValueById(i);
			//显示提高属性
			strContent += StaticMethod.getPropertyStr(oProItem.m_nType, nValue, bIsInteger) + " -> "
						  + StaticMethod.getPropertyStrNoTitle(nValue2, bIsInteger) + "\n";

			//回复等级
			oEquip.m_oCoe.m_nLv--;
		}
		//
		return strContent;
	},
	//买道具信息
	sellEquipMessage : function(oEquip)
	{
		var strContent = "出售" + oEquip.m_oData.Name;
		return strContent;
	},
	//丢道具回调
	discardEquipMessage : function(oEquip)
	{
		var strContent = "丢弃" + oEquip.m_oData.Name + "? \n" + "丢弃之后将无法找回。";
		return strContent;
	},

	//---------------------------------------------------------------------------------------------------------------------------

	//解锁
	unLockEquipBoxMessage : function()
	{
		var strContent = "确定要解锁吗？\n您会增加一个装备槽！";
		return strContent;
	},
	unLockFloorMessage : function()
	{
		var strContent = "确定解锁下一层吗？\n挑战已通关塔层可获得足够的金币。";
		return strContent;
	},

	//金币不足
	enoughCoin : function()
	{
		var strContent = "没有足够的金币，\n是否到商店看看？";
		return strContent;
	},
	
	//---------------------------------------------------------------------------------------------------------------------------

	//上层
	passSmallFloor : function()
	{
		var strContent = "前往下一层吗？\n请确保您有足够的实力。";
		return strContent;
	},
	passBigFloor : function()
	{
		var strContent = "确定要回到主菜单？\n这将保存您的进度但会丢失这部分的等级和经验！";
		return strContent;
	},
	passOutFloor : function()
	{
		var strContent = "恭喜您挑战完本层！";
		return strContent;
	},

	//------------------------------------------------------------------------------------------------
	
	//退出塔
	outTowerMessage : function()
	{
		var strContent = "退出迷宫吗？\n背包的物品将会丢失并且装备会重置。";
		return strContent;
	}
};