/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/4/22
 * Time: 上午11:03
 * To change this template use File | Settings | File Templates.
 */


var gameCourse = gameCourse || {};


var lyCourse = vee.Class.extend({

	/** cc.node */
	m_noContain : null,
	/** cc.button */
	m_btnPlayer : null,
	/** cc.button */
	m_btnShop : null,
	/** cc.sprite */
	m_spFinger : null,
	/** cc.sprite */
	m_spArrow : null,
	/** eleHand */
	m_eleHand : null,

	//目标
	m_lyCurrentLayer : null,
	//类型
	m_nType : 0,
	//位置
	m_pointFinger : null,

	//---------------------------------------------------------------------------------------------------------------------------
	//初始化
	setLyCourse : function(nType, lyLayer)
	{
		this.m_nType = nType
		this.m_lyCurrentLayer = lyLayer;
		var pointBtn = this.m_noContain.convertToNodeSpace(this.m_lyCurrentLayer.m_pointBtn);
		this.m_btnPlayer.setPosition(pointBtn);
		var pointArrow = cc.p(pointBtn.x - 30, pointBtn.y + (this.m_btnPlayer.getContentSize().height/3+this.m_spArrow.getContentSize().height/2));
		this.m_spArrow.setPosition(pointArrow);
		//
		switch (nType)
		{
			case CourseType.CourseMove:
			{
				//初始化触控层
				var lyTouchLayer = cc.LayerColor.create(cc.color(0,0,0,10), 0, 0);
				vee.GestureController.registerController(lyTouchLayer, this);
				this.rootNode.addChild(lyTouchLayer);
				//效果
				this.playAnimate("tutorial_1", null, false);

				//
				gameCourse = this;
				this.m_pointFinger = this.m_spFinger.getPosition();
				var pointTarget = cc.p(this.m_pointFinger.x + 200, this.m_pointFinger.y);
				switch (this.getDirection())
				{
					case 1:
					{
						pointTarget = cc.p(this.m_pointFinger.x, this.m_pointFinger.y-200);
					}
						break;
					case 2:
					{
						pointTarget = cc.p(this.m_pointFinger.x-200, this.m_pointFinger.y);
					}
						break;
					case 4:
					{
						pointTarget = cc.p(this.m_pointFinger.x, this.m_pointFinger.y+200);
					}
						break;
					case 8:
					{
						pointTarget = cc.p(this.m_pointFinger.x + 200, this.m_pointFinger.y);
					}
						break;
				}
				//
				var action1 = cc.moveTo(1, pointTarget);
				var action2 = cc.delayTime(0.5);
				var action3 = cc.CallFunc.create(function(){
					this.setPosition(gameCourse.m_pointFinger);
				}, this.m_spFinger);
				var action4 = cc.sequence(action1, action2, action3);
				this.m_spFinger.runAction(cc.repeatForever(action4));
			}
				break;
			case CourseType.CourseGetWeapon:
			{
				this.playAnimate("tutorial_2", null, false);
			}
				break;
			case CourseType.CourseFirstLose:
			{
				this.playAnimate("tutorial_3", null, false);
			}
				break;
			case CourseType.CourseFirstOutTower:
			{
				var pointBtn2 = this.m_noContain.convertToNodeSpace(this.m_lyCurrentLayer.m_pointBtn2);
				this.m_btnShop.setPosition(pointBtn2);
				var pointArrow = cc.p(pointBtn.x - 30, pointBtn.y + (this.m_btnShop.getContentSize().height/3+this.m_spArrow.getContentSize().height/2));
				this.m_spArrow.setPosition(pointArrow);

				this.playAnimate("tutorial_7", null, false);
			}
				break;
			case CourseType.CourseFirstInGame:
			{
				//初始化触控层
				var lyTouchLayer = cc.LayerColor.create(cc.color(0,0,0,10), 0, 0);
				vee.GestureController.registerController(lyTouchLayer, this);
				this.rootNode.addChild(lyTouchLayer);

				var towerPosition = this.m_noContain.convertToNodeSpace(this.m_lyCurrentLayer.m_pointTower);
				this.playAnimate("tutorial_5", null, false);
				this.m_eleHand.setPosition(towerPosition);
				this.m_eleHand.controller.playAnimate("movehand", null, false);
			}
				break;
			case CourseType.CourseMap:
			{
				//初始化触控层
				var lyTouchLayer = cc.LayerColor.create(cc.color(0,0,0,10), 0, 0);
				vee.GestureController.registerController(lyTouchLayer, this);
				this.rootNode.addChild(lyTouchLayer);

				this.playAnimate("tutorial_6", null, false);
			}
				break;
			case CourseType.CourseFirstWinTower:
			{
				this.playAnimate("tutorial_4", null, false);
			}
				break;
		}
	},

	//
	getDirection : function()
	{
		var nTileTpe = MapManager.getStepData(MapManager.getStartStep());
		var nIndex = 1;
		for(var i = 0; i < 4; i++)
		{
			if((nTileTpe & nIndex) == nIndex){
				return nIndex;
			}
			nIndex  = nIndex << 1;
		}
		return 8;
	},

	//---------------------------------------------------------------------------------------------------------------------------
	//按钮回调
	//触控
	onGestureLeave : function(context)
	{
		vee.PopMgr.closeLayerByCtl(this);
	},
	//按钮
	onCourseBtn : function()
	{
		vee.PopMgr.closeLayerByCtl(this);
		//
		switch (this.m_nType)
		{
			case CourseType.CourseGetWeapon:
			{
				this.m_lyCurrentLayer.courseGetWeaponCallBack();
			}
				break;
			case CourseType.CourseFirstLose:
			{
				this.m_lyCurrentLayer.openPlayer();
			}
				break;
			case CourseType.CourseFirstWinTower:
			{
				this.m_lyCurrentLayer.openPlayer();
			}
				break;
		}
	},
	//按钮
	onCourseBtn2 : function()
	{
		vee.PopMgr.closeLayerByCtl(this);
		//
		switch (this.m_nType)
		{
			case CourseType.CourseFirstOutTower:
			{
				this.m_lyCurrentLayer.openShop();
			}
				break;
		}
	}
});
cc.BuilderReader.registerController("lyCourse", lyCourse);


var eleHand = vee.Class.extend({

});
cc.BuilderReader.registerController("eleHand", eleHand);