/**
 * Created with AppCode.
 * User: Yop Chan
 * Date: 15/1/20
 * Time: 下午5:20
 * To change this template use File | Settings | File Templates.
 */


var lyMainUiLayer = vee.Class.extend({

	//显示控件
	/** @expose */
	m_noUp : null,
	/** @expose */
	m_noDown : null,

	/** @expose */
	m_noMoney : null,
	/** @expose */
	m_lbMoney : null,
	/** @expose */
	m_noGem : null,
	/** @expose */
	m_lbJewel : null,
	/** @expose */
	m_spJewelIcon : null,
	
	/** @expose */
	m_gLogo : null,

	/** @expose */
	m_noShop : null,
	/** cc.button */
	m_btnPlayer : null,
	/** @expose */
	m_btnShop : null,

	/** @expose */
	m_noDesc : null,
	/** @expose */
	m_lbDesc : null,
	/** @expose */
	m_btnChests : null,
	
	/** @expose */
	m_btnMore : null,
	/** @expose */
	m_btnAbout : null,
	
	//---------------------------
	//中介对象
	m_lyMainLayer : null,

	//------------------------------------------------------------------------------------------------------------
	//设置

	setMainLayer : function(lyMainLayer)
	{
		this.m_lyMainLayer = lyMainLayer;
	},
	//得到按钮位置
	getPlayerBtnPosition : function()
	{
		return this.m_btnPlayer.getParent().convertToWorldSpace(this.m_btnPlayer.getPosition());
	},
	//得到按钮位置
	getPlayerBtnPosition2 : function()
	{
		return this.m_btnShop.getParent().convertToWorldSpace(this.m_btnShop.getPosition());
	},
	
	//------------------------------------------------------------------------------------------------------------
	//设置
	
	//修改显示金钱
	setDisplayMoney : function(nMoney)
	{
		if(!nMoney){
			nMoney = GameManager.getVIPData().m_nMoney;
		}
		var strMoney = StaticMethod.setMoneyString(nMoney);
		this.m_lbMoney.setString(strMoney);
	},
	//修改显示钻石
	setDisplayJewel : function(nMoney)
	{
		if(!nMoney){
			nMoney = vee.VIPValues.getValue(VipKey.Jewel);
		}
		var strMoney = StaticMethod.setMoneyString(nMoney);
		this.m_lbJewel.setString(strMoney);
		this.m_spJewelIcon.setPositionX(this.m_lbJewel.getPosition().x 
										- (this.m_lbJewel.getContentSize().width + 5));
	},

	//------------------------------------------------------------------------------------------------------------
	//初始化

	onCreate : function()
	{
		//初始化位置
		vee.PopMgr.resetLayer(this.m_noUp, vee.PopMgr.PositionType.Top, cc.p(0, 0), true);
		vee.PopMgr.resetLayer(this.m_noDown, vee.PopMgr.PositionType.Bottom, cc.p(0, 20), true);
		//设置金币，钻石位置
		vee.PopMgr.resetLayer(this.m_noMoney, vee.PopMgr.PositionType.TopLeft,  cc.p(50, -100), true);
		vee.PopMgr.resetLayer(this.m_noGem, vee.PopMgr.PositionType.TopRight, cc.p(0, -70),   true);
		vee.PopMgr.resetLayer(this.m_gLogo, vee.PopMgr.PositionType.Top, cc.p(0, 0),   true);
		vee.PopMgr.resetLayer(this.m_noShop, vee.PopMgr.PositionType.BottomRight, cc.p(-70, 0),   true);
		vee.PopMgr.resetLayer(this.m_noDesc, vee.PopMgr.PositionType.BottomLeft, cc.p(25, 0),   true);
		
		//初始化金钱显示
		this.setDisplayMoney(0);
		this.setDisplayJewel(0);

		//设置通知
		MyNotificationCenter.addObserver(this, GameEvent.UPDATAEGAMEMONEY, this.setDisplayMoney);
		MyNotificationCenter.addObserver(this, GameEvent.UPDATAEGAJEWEL, this.setDisplayJewel);

		//设置公告
		this.m_lbDesc.setString("");

		//Compass冷却
		GameManager.calCompass();

		//电信不能屏蔽
		if (app.CURRENT_PUBLIC_SDK == app.PUBLIC_SDK.EGAME)
		{
			
		}
		else
		{
			this.m_btnMore.setVisible(false);
			this.m_btnAbout.setVisible(false);
			this.m_gLogo.setVisible(false);
		}
	},

	//关闭界面
	onClosed : function()
	{
		//移除通知
		MyNotificationCenter.removeObserver(this, GameEvent.UPDATAEGAMEMONEY);
		MyNotificationCenter.removeObserver(this, GameEvent.UPDATAEGAJEWEL);
	},

	//------------------------------------------------------------------------------------------------------------
	//效果相关

	//显示ui
	showUi : function()
	{
		this.playAnimate("GameStart", this.showUiCallBack.bind(this), false);
	},
	//显示ui回调
	showUiCallBack : function()
	{
		this.m_lyMainLayer.showFirstAward();
	},

	//------------------------------------------------------------------------------------------------------------
	//按钮回调

	/** @expose */
	openMoreGame : function()
	{
		vee.IAPMgr.openMoreGame();
	},
	/** @expose */
	openAboutGame : function()
	{
		this.m_lyMainLayer.openAboutGame();
	},
	/** @expose */
	openChests : function()
	{
		this.m_lyMainLayer.openChests();
	},
	/** @expose */
	openPlayer  : function(pSender)
	{
		this.m_lyMainLayer.openPlayer();
	},
	/** @expose */
	openBank  : function(pSender)
	{
		this.m_lyMainLayer.openBank();
	},
	/** @expose */
	openShop  : function(pSender)
	{
		//统计
		var oMes = {
			"TowerNumber" : '' + GameManager.getVIPData().m_nOpenFloor,
			"Jewel"       : '' + (Math.floor(vee.VIPValues.getValue(VipKey.Jewel) / 10) * 10)
		};
		vee.Analytics.logEvent(StatEventId.ClickShop, oMes);
		//
		this.m_lyMainLayer.openShop();
	},
	/** @expose */
	topUp  : function(pSender)
	{
		//统计
		var oMes = {
			"TowerNumber" : '' + GameManager.getVIPData().m_nOpenFloor,
			"Jewel"       : '' + (Math.floor(vee.VIPValues.getValue(VipKey.Jewel) / 10) * 10)
		};
		vee.Analytics.logEvent(StatEventId.ClickPlus, oMes);
		//
		this.m_lyMainLayer.openShop();
	}
});
cc.BuilderReader.registerController("lyMainUiLayer", lyMainUiLayer);